
# Time
scoreboard objectives add time dummy
execute if score @s finished matches 0 run scoreboard players add @s time 1
execute positioned 6 -2028 6 run scoreboard players set @s[dx=1,dy=1,dz=1] time 0
scoreboard objectives add last_checkpoint dummy
scoreboard players add @s last_checkpoint 0
execute positioned 6 -2028 6 run scoreboard players set @s[dx=1,dy=1,dz=1] last_checkpoint 0
execute positioned 6 -2028 6 run scoreboard players set @s[dx=1,dy=1,dz=1] finished 0
execute positioned 6 -2028 6 run spawnpoint @s[dx=1,dy=1,dz=1] 7 -2028 7 180

scoreboard players operation hours globals = @s time
scoreboard players set tmp globals 72000
scoreboard players operation hours globals /= tmp globals
data modify storage justgoup:main hours_text set value ""
execute if score hours globals matches 1.. run data modify storage justgoup:main hours_text set value [{score:{objective:"globals",name:"hours"}},":"]

scoreboard players operation minutes globals = @s time
scoreboard players set tmp globals 1200
scoreboard players operation minutes globals /= tmp globals
scoreboard players set tmp globals 60
scoreboard players operation minutes globals %= tmp globals
data modify storage justgoup:main minutes_zero set value ""
execute if score minutes globals matches ..9 if score hours globals matches 1.. run data modify storage justgoup:main minutes_zero set value "0"

scoreboard players operation seconds globals = @s time
scoreboard players set tmp globals 20
scoreboard players operation seconds globals /= tmp globals
scoreboard players set tmp globals 60
scoreboard players operation seconds globals %= tmp globals
data modify storage justgoup:main seconds_zero set value ""
execute if score seconds globals matches ..9 run data modify storage justgoup:main seconds_zero set value "0"
data modify storage justgoup:main raw_time_text set value [{nbt:"hours_text",storage:"justgoup:main",interpret:true},{nbt:"minutes_zero",storage:"justgoup:main"},{score:{objective:"globals",name:"minutes"}},":",{nbt:"seconds_zero",storage:"justgoup:main"},{score:{objective:"globals",name:"seconds"}}]
data modify storage justgoup:main time_text set value [{text:"Time: ",color:"gold"},{color:"green",text:"",extra:[{nbt:"raw_time_text",storage:"justgoup:main",interpret:true}]}]

# Generates stats string
function justgoup:actionbar/stats

# Height
function justgoup:actionbar/height

# Placing relative to others
scoreboard players set place globals 1
scoreboard players set total_players globals 0
scoreboard players operation tmp globals = @s height
execute as @a if score @s height > tmp globals run scoreboard players add place globals 1
execute as @a run scoreboard players add total_players globals 1
data modify storage justgoup:main place_suffix set value "th"
execute if score place globals matches 1 run data modify storage justgoup:main place_suffix set value "st"
execute if score place globals matches 2 run data modify storage justgoup:main place_suffix set value "nd"
execute if score place globals matches 3 run data modify storage justgoup:main place_suffix set value "rd"
# Place-text also has space before it because it may not be present if there is only one player
data modify storage justgoup:main place_text set value ["   ",{text:"Place: ",color:"gold"},{score:{objective:"globals",name:"place"},color:"green"},{nbt:"place_suffix",storage:"justgoup:main",color:"green"}]
execute if score total_players globals matches 1 run data modify storage justgoup:main place_text set value ""

function justgoup:actionbar/minimap

title @s times 0 1 0
execute if score @s checkpoint_display matches 1.. run title @s actionbar {text:"Checkpoint saved!",color:"green"}
execute unless score @s checkpoint_display matches 1.. run title @s actionbar [{nbt:"height_text",storage:"justgoup:main",interpret:true},{text:"   "},{nbt:"dots",storage:"justgoup:main"},{text:"   "},{nbt:"time_text",storage:"justgoup:main",interpret:true},{nbt:"place_text",storage:"justgoup:main",interpret:true}]
execute if score @s checkpoint_display matches 1.. run scoreboard players remove @s checkpoint_display 1